#ifndef _NVMX_COMPILER_H
#define _NVMX_COMPILER_H


#ifndef likely
#if __GNUC__ < 3
#define __builtin_expect(x, n) (x)
#endif

#define MB_TO_BYTES_SHIFT 20

#define likely(x)   __builtin_expect(!!(x), 1)
#define unlikely(x)   __builtin_expect(!!(x), 0)
#endif

/* assume little endianess */
#define cpu_to_le64(x) x
#define cpu_to_le32(x) x
#define cpu_to_le16(x) x

#define le64_to_cpu(x) x
#define le32_to_cpu(x) x
#define le16_to_cpu(x) x

#define nvmx_min(a,b) (((a)<(b))?(a):(b))
#define nvmx_max(a,b) (((a)>(b))?(a):(b))

#define NVME_PACKED  __attribute__((packed))

#define member_size(type, member) sizeof(((type *)0)->member)

#ifndef offsetof
#define offsetof(t, m) ((size_t) &((t *)0)->m)
#endif

#ifndef container_of
#define container_of(ptr, type, member) ({ \
		typeof(((type *)0)->member)*__mptr = (ptr); \
		(type *)((char *)__mptr - offsetof(type, member)); })
#endif

#endif
