/*
 * Mellanox NVMe Namespace Object.
 */
#ifndef _MLX_NVME_EMU_NAMESPACE_H
#define _MLX_NVME_EMU_NAMESPACE_H

#include <stdint.h>

#include "devx_verbs.h"

typedef struct mlx_nvme_namespace_attr mlx_nvme_namespace_attr_t;
typedef struct mlx_nvme_namespace mlx_nvme_namespace_t;

struct mlx_nvme_namespace_attr {
    uint32_t src_nsid;
    uint32_t dst_nsid;
    uint16_t metadata_size;
    uint8_t lba_size;
    uint32_t device_emulation_id;
    uint32_t counter_set_id;
};

struct mlx_nvme_namespace {
    devx_ctx_t             *devx_ctx;
    struct devx_obj_handle *objh;
    uint32_t                id;
};

mlx_nvme_namespace_t *mlx_nvme_namespace_create(devx_ctx_t *devx_ctx,
                                                mlx_nvme_namespace_attr_t *attr);
int mlx_nvme_namespace_destroy(mlx_nvme_namespace_t *ns);
int mlx_nvme_namespace_query(mlx_nvme_namespace_t *ns,
                             mlx_nvme_namespace_attr_t *attr_out,
                             uint64_t *modifiable_fields);
int mlx_nvme_namespace_modify(mlx_nvme_namespace_t *ns,
                              mlx_nvme_namespace_attr_t *attr_in,
                              uint64_t fields_to_modify);

#endif
