/*
 * Mellanox SF (Sub Function)
 */
#ifndef _MLX_SF_H
#define _MLX_SF_H

#include <stdint.h>

#include "devx_verbs.h"

typedef struct mlx_sf mlx_sf_t;

struct mlx_sf {
    devx_ctx_t              sf;
    struct ibv_pd           *pd;

    devx_ft_t               ft_sf_rx;
    devx_fg_t               fg_sf_rx;
    devx_fte_t              fte_sf_rx;

    uint32_t                dma_rkey;
};

struct ibv_cq *mlx_sf_create_cq(mlx_sf_t *sf, int cq_len, void *user_ctx,
                                struct ibv_comp_channel *channel, int vector);
void mlx_sf_destroy_cq(struct ibv_cq *cq);
struct ibv_pd *mlx_sf_alloc_pd(mlx_sf_t *sf);
void mlx_sf_dealloc_pd(struct ibv_pd *pd);
struct ibv_comp_channel *mlx_sf_create_comp_channel(mlx_sf_t *sf);
void mlx_sf_destroy_comp_channel(struct ibv_comp_channel *channel);
mlx_sf_t *mlx_sf_alloc(const char *if_name);
void mlx_sf_free(mlx_sf_t *sf);
#endif
