#ifndef _NVME_PRP_H
#define _NVME_PRP_H

/* PRP list handling */

#define PRP_PAGE_SIZE(pbits) (1<<(pbits))
#define PRP_PAGE_BASE(prp, pbits) ((prp) & ~(PRP_PAGE_SIZE(pbits) - 1))
#define PRP_PAGE_OFFSET(prp, pbits) ((prp) & (PRP_PAGE_SIZE(pbits) - 1))

enum {
    PRP_DIR_WRITE, 
    PRP_DIR_READ
};

/* Read/write short prp list.
 * The length of data must not exceed two PRP pages
 */
void nvme_prp_rw_short(nvme_queue_ops_t *ops, uint64_t prp1, uint64_t prp2, void *buf,
                       size_t len, unsigned pbits, int dir);

/* write data to prp */
static inline void
nvme_prp_write_short(nvme_queue_ops_t *ops, uint64_t prp1, uint64_t prp2, void *buf, size_t len, unsigned pbits)
{
    nvme_prp_rw_short(ops, prp1, prp2, buf, len, pbits, PRP_DIR_WRITE);
}

/* read data from prp */
static inline void
nvme_prp_read_short(nvme_queue_ops_t *ops, uint64_t prp1, uint64_t prp2, void *buf, size_t len, unsigned pbits)
{
    nvme_prp_rw_short(ops, prp1, prp2, buf, len, pbits, PRP_DIR_READ);
}

#endif
