#ifndef _NVME_SGL_H
#define _NVME_SGL_H

#include "nvme.h"

enum {
    SGL_DIR_WRITE, 
    SGL_DIR_READ
};

/* 
 * Read/write to/from sgl.
 * The length of data must not the maximal io size
 */
void nvme_sgl_rw(nvme_queue_ops_t *ops, nvme_sgl_desc_t *sgl, void *buf,
                 size_t len, unsigned pbits, int dir);

/* write data to sgl */
static inline void
nvme_sgl_write(nvme_queue_ops_t *ops, nvme_sgl_desc_t *sgl, void *buf,
               size_t len, unsigned pbits)
{
    nvme_sgl_rw(ops, sgl, buf, len, pbits, SGL_DIR_WRITE);
}

/* read data from sgl */
static inline void
nvme_sgl_read(nvme_queue_ops_t *ops, nvme_sgl_desc_t *sgl, void *buf,
              size_t len, unsigned pbits)
{
    nvme_sgl_rw(ops, sgl, buf, len, pbits, SGL_DIR_READ);
}

#endif
