#!/bin/bash -eE
# (c) 2019 Mellanox Technologies
# Author: Yurii Shestakov
#------------------------------------------------------------------------
CFG=$1
CFG_FN="/etc/nvme_snap/$CFG.json"
logger -p local0.notice -t nvme_snap "$0: $1"
# compatability with old configuration
# when we have no systemd unit template: nvme_snap@.service
if [ -z "$CFG" ] ; then
    echo -e "Usage: $0 nvme0\nwhere nvme0 is a name of JSON file in /etc/nvme_snap/nvme0.json" >&2
    exit 1
fi

# Now read the env varibles
# 1st - most specific - /etc/default/nvme_snap.$MLX_DEV
# 2nd - generic - /etc/default/nvme_snap  if the above doesn't exists
#
env_fn=/etc/default/nvme_snap
logger -p local0.notice -t nvme_snap "$CFG: env_fn: $env_fn"
if [ -e "$env_fn" ] ; then
    source "$env_fn"
fi
if [ ! -e "$CFG_FN" ] ; then
    logger -p local0.err -t nvme_snap "$CFG: $CFG_FN doesn't exist. Exit"
    # EX_CONFIG
    exit 78
fi
if [ -n "$NVME_SNAP_LOGFILE_PATH" ] ; then
  logger -p local0.notice -t nvme_snap "$CFG: NVME_SNAP_LOGFILE_PATH: $NVME_SNAP_LOGFILE_PATH"
fi

exec /usr/bin/nvme_controller_emu $CFG_FN
