#!/bin/bash  -eE
# Copyright (c) 2019 Mellanox Technologies. All rights reserved.
# Create OVS bridge and proper configuration for NVMe SF to work
 
for N in 0 1 ; do 
  if ! ovs-vsctl br-exists Br$N ; then
    logger -p local0.notice -t nvme_snap "$0: Configure bridge Br$N..."
    ovs-vsctl add-br Br$N
    ovs-vsctl add-port Br$N p$N
  else
    ports=`ovs-vsctl list-ports Br$N`
    if echo $ports | grep -wq p$N > /dev/null ; then
      logger -p local0.notice -t nvme_snap "$0: Port p$N already configured for bridge Br$N..."
    else
      logger -p local0.notice -t nvme_snap "$0: Configure port p$N for bridge Br$N..."
      ovs-vsctl add-port Br$N p$N
    fi
  fi
done
ovs-vsctl set Open_vSwitch . Other_config:hw-offload=true
